//
// 17./18.12.2014 / RHS
// Zeitnachweise drucken
// Multi-Page und Multi-Line im Eigenbau, dafr funktionsfhig ...
//
// 04.02.2015 / RHS / AEs rechtsbndig, AE-Summe ausgeben

// Include the main TCPDF library (search for installation path).
include_once($this->Ini->path_third . '/tcpdf/tcpdf.php');

// Neues PDF Dokument mit der Klasse ZNW_PDF (siehe Tools / Libraries / Project / znw_header_footer.php)
// erstellen. Dort sind auch Header (mit Hintergrundbild) und Footer definiert.
$pdf = new ZNW_PDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);

// set document information
$pdf->SetCreator(PDF_CREATOR);
$pdf->SetAuthor('efense GmbH');
$pdf->SetTitle('Zeitnachweis');
$pdf->SetSubject('KIS Zeitnachweis');
$pdf->SetKeywords('KIS Zeitnachweis');

// set default header data
$pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, PDF_HEADER_TITLE, PDF_HEADER_STRING);

// set header and footer fonts
$pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
$pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

// set default monospaced font
$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

// set margins
$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

// set auto page breaks
$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

// set image scale factor
$pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);

// set some language-dependent strings (optional)
if (@file_exists(dirname(__FILE__).'/lang/eng.php')) {
    require_once(dirname(__FILE__).'/lang/eng.php');
    $pdf->setLanguageArray($l);
}

// ---------------------------------------------------------

// Beginn der Detail-Zeilen
$pdf->SetTopMargin(110);

// AutoPageBreak einschalten, 60 mm unterer Rand
$pdf->SetAutoPageBreak(true, 60);

//
// Kopf-Daten
//

$sql = "SELECT Mandant, NachweisID, Datum, Status, Einsatzart, 
               DebitorID, DebitorName1, DebitorStrasse, DebitorPLZ, DebitorOrt, Ansprechpartner,
			   MitarbeiterID
	      FROM Zeitnachweis
         WHERE Mandant=" . [app_mandant] . " AND NachweisID IN (" . [var_NachweisID] . ")
         ORDER BY NachweisID";

sc_select(rs, $sql);

if (false == {rs})     // Error while accessing database
{
    // sc_error_message('Fehler beim Zugriff auf die Datenbank!');
}
else
{
	while(!$rs->EOF)
	{
		// Kundendaten	   
		$NachweisID             = $rs->fields[1];
		$NachweisDatum          = date("d.m.Y", strtotime($rs->fields[2]));
		$DebitorID              = $rs->fields[5];
		$DebitorName1           = utf8_encode($rs->fields[6]);
		$DebitorStrasse         = utf8_encode($rs->fields[7]);
		$DebitorPLZ             = $rs->fields[8];
		$DebitorOrt             = utf8_encode($rs->fields[9]);
		$DebitorAnsprechpartner = utf8_encode($rs->fields[10]);
		$MitarbeiterID          = $rs->fields[11];
		$BarcodeNachweisID      = str_pad($rs->fields[1], 7 ,'0', STR_PAD_LEFT);		
		
		// neue Seite anlegen
		$pdf->AddPage();
		
		// Kopf
		$x = 62;
		
		$pdf->SetXY($x-45, 11);

		// define barcode style
		$style = array('text'        => true,
					   'stretchtext' => 0);
		$pdf->write1DBarcode($BarcodeNachweisID, 'C39', '', '', '', 10, 0.4, $style, 'N');
		
		$pdf->SetXY($x, 51);
		$pdf->Write(0, $DebitorName1);

		$pdf->SetXY($x, 60);
		$pdf->Write(0, $DebitorAnsprechpartner);
		
		$pdf->SetXY($x, 68);
		$pdf->Write(0, $DebitorStrasse);

		$pdf->SetXY($x, 77);
		$pdf->Write(0, $DebitorPLZ);

		$pdf->SetXY($x + 15, 77);
		$pdf->Write(0, $DebitorOrt);
		
		// Fuss ausgeben, dafr AutoPageBreak abschalten, 
		// damit keine neue Seite generiert wird
		$pdf->SetAutoPageBreak(false, 60);

		// Mitarbeiter-Daten holen ...
		$sql_ma = "SELECT concat(Vorname, ' ', Nachname) 
		             FROM Mitarbeiter 
                    WHERE MitarbeiterID='" . $MitarbeiterID ."'
                    ORDER BY Vorname, Nachname";		
		
		sc_lookup(rs_ma, $sql_ma);

		if (isset({rs_ma[0][0]}))     // Row found
		{
			$MitarbeiterName = utf8_encode({rs_ma[0][0]});
		}
				else     // No row found
		{
			$MitarbeiterName = '';
		}		
		
		// ... und ausgeben
		$pdf->SetXY(18, 247);
		$pdf->Write(0, $MitarbeiterName);
		
		$pdf->SetXY(18, 280);
		$pdf->Write(0, $NachweisDatum);

		// AutoPageBreak wieder einschalten
		$pdf->SetAutoPageBreak(true, 60);		
		
        //
		// Positionen
		//									  
		
		$sql = "SELECT Datum, Start, Ende, Beschreibung, AnzahlAE, Anfahrt
		          FROM ZeitnachweisDetails
				 WHERE NachweisID=" . $NachweisID . "
				 ORDER BY NachweisDetailID";
											  
		sc_select(rspos, $sql);

		if (false == {rspos})     // Error while accessing database
		{
			// sc_error_message('Fehler beim Zugriff auf die Datenbank!');
		}
		else
		{
			
			$y = 110;
			$pdf->SetY($y);
			
			$SummeAnzahlAE = 0;
			
			while(!$rspos->EOF)
			{

				// die aktuelle Seitenanzahl merken
  		        $num_pages = $pdf->getNumPages();
				
				// Transaktion starten
        	    $pdf->startTransaction();
  				
				// Details
				$DetailDatum  = date("d.m.Y", strtotime($rspos->fields[0]));
				$Start        = date("H:i", strtotime($rspos->fields[1]));
				$Ende         = date("H:i", strtotime($rspos->fields[2]));
				$Beschreibung = trim(utf8_encode($rspos->fields[3]));
				$AnzahlAE     = number_format($rspos->fields[4], 2, ",", ".");
				$Anfahrt      = $rspos->fields[5];
				
				$SummeAnzahlAE = $SummeAnzahlAE + $rspos->fields[4];

				$pdf->SetX(16);
				$pdf->Write(0, $DetailDatum);
				
				$pdf->SetX(42);
				$pdf->Write(0, $Start);
				
				$pdf->SetX(59);
				$pdf->Write(0, $Ende);

				$pdf->SetX(167);
				// 04.02.2015 / RHS
				// Zahl rechtsbndig formatieren geht nur mit Cell(), 
				// Write() bezieht sich auf die Gesamtbreite der Seite
				// $pdf->Write(0, $AnzahlAE, '', true, 'R');
				$pdf->Cell(10, 0, $AnzahlAE, 0, 0, 'R');
				
				$pdf->SetX(180);
				if ($Anfahrt == 0)
				{	
					$pdf->Write(0, 'nein');
				}	
				else
				{	
					$pdf->Write(0, 'ja');
				}
				
				// Schriftgre merken
				$fontsize = $pdf->getFontSizePt();
				
				// kleine Schriftgre setzen
				$pdf->SetFontSize(9);
				
				$pdf->SetX(74);
				$pdf->SetFillColor(255, 255, 255);				
  			    $pdf->MultiCell(90, 0, $Beschreibung . "\n", 0, 'J', 1, 1, '' ,'', false, 0);				
				
				// Schriftgre restaurieren
				$pdf->SetFontSize($fontsize);
					
				// $pdf->Ln();

				// wurde ein automatischer Seitenumbruch erzeugt?
 			    if($num_pages < $pdf->getNumPages())
				{
					// Transaktion rckgngig machen
					$pdf->rollbackTransaction(true);
					
					// neue Seite anlegen
					$pdf->AddPage();

					// Kopfdaten (erneut) ausgeben
					$x = 62;
					
					$pdf->SetXY($x-45, 11);

					// define barcode style
					$style = array('text'        => true,
								   'stretchtext' => 0);
					$pdf->write1DBarcode($BarcodeNachweisID, 'C39', '', '', '', 10, 0.4, $style, 'N');
					
					$pdf->SetXY($x, 51);
					$pdf->Write(0, $DebitorName1);

					$pdf->SetXY($x, 60);
					$pdf->Write(0, $DebitorAnsprechpartner);

					$pdf->SetXY($x, 68);
					$pdf->Write(0, $DebitorStrasse);

					$pdf->SetXY($x, 77);
					$pdf->Write(0, $DebitorPLZ);

					$pdf->SetXY($x + 15, 77);
					$pdf->Write(0, $DebitorOrt);

					// Fuss (erneut) ausgeben, dafr AutoPageBreak abschalten, 
					// damit keine neue Seite generiert wird
					$pdf->SetAutoPageBreak(false, 60);

					// Mitarbeiterdaten holen ...
					$sql_ma = "SELECT concat(Vorname, ' ', Nachname) 
							     FROM Mitarbeiter 
							    WHERE MitarbeiterID='" . $MitarbeiterID ."'
							    ORDER BY Vorname, Nachname";		

					sc_lookup(rs_ma, $sql_ma);

					if (isset({rs_ma[0][0]}))     // Row found
					{
						$MitarbeiterName = utf8_encode({rs_ma[0][0]});
					}
							else     // No row found
					{
						$MitarbeiterName = '';
					}		

					// ... und ausgeben
					$pdf->SetXY(18, 247);
					$pdf->Write(0, $MitarbeiterName);

					$pdf->SetXY(18, 280);
					$pdf->Write(0, $NachweisDatum);

					// AutoPageBreak wieder einschalten
					$pdf->SetAutoPageBreak(true, 60);		
					
					// aktuelle Position nochmal drucken (wurde vorher durch Rollback rckgngig gemacht)
					$y = 110;
					$pdf->SetY($y);
					
					$pdf->SetX(16);
					$pdf->Write(0, $DetailDatum);

					$pdf->SetX(42);
					$pdf->Write(0, $Start);

					$pdf->SetX(59);
					$pdf->Write(0, $Ende);

					$pdf->SetX(167);
					// 04.02.2015 / RHS
					// Zahl rechtsbndig formatieren geht nur mit Cell(), 
					// Write() bezieht sich auf die Gesamtbreite der Seite
					// $pdf->Write(0, $AnzahlAE, '', true, 'R');
					$pdf->Cell(10, 0, $AnzahlAE, 0, 0, 'R');

					$pdf->SetX(180);
					if ($Anfahrt == 0)
					{	
						$pdf->Write(0, 'nein');
					}	
					else
					{	
						$pdf->Write(0, 'ja');
					}
					
					// Schriftgre merken
					$fontsize = $pdf->getFontSizePt();
					
					// kleine Schriftgre setzen
					$pdf->SetFontSize(9);

					$pdf->SetX(74);
					$pdf->SetFillColor(255, 255, 255);				
					$pdf->MultiCell(90, 0, $Beschreibung . "\n", 0, 'J', 1, 1, '' ,'', false, 0);			
					
					// Schriftgre restaurieren
					$pdf->SetFontSize($fontsize);
					
				}
				else
				{
					// Otherwise we are fine with this row, discard undo history.
					$pdf->commitTransaction();
				}

				// nchste Details
				$rspos->MoveNext();
			}
			
			// Gesamtsumme ausgeben
			$SummeAnzahlAE = number_format($SummeAnzahlAE, 2, ",", ".");				

			$pdf->SetAutoPageBreak(false, 60);		
			$pdf->SetXY(167, 247);
			$pdf->Cell(10, 0, $SummeAnzahlAE, 0, 0, 'R');
			$pdf->SetAutoPageBreak(true, 60);		
			
			// Summenzhler zurcksetzen
			$SummeAnzahlAE = 0;

			$rspos->Close();
		}	
		
        // nchster Zeitnachweis
		$rs->MoveNext();
	}
	
	$rs->Close();
}

// ---------------------------------------------------------

//Close and output PDF document
$pdf->Output('zeitnachweis.pdf', 'I');

// gedruckt-Kennzeichen setzen
// Status nur ndern, falls Status = 0
$sql = "UPDATE Zeitnachweis SET Status=(IF(Status=0,1,Status)) WHERE NachweisID IN ([var_NachweisID])";

sc_exec_sql($sql);


